-- Input parameters
-- dbweb-tables-count - number of tables to create
--
--
--

function create_insert(table_id)

   local index_name
   local i
   local j
   local query

   i = table_id


   print("Creating table sbtest" .. i)
   db_query("CREATE DATABASE sbtest" .. i)
   db_query("USE sbtest" .. i)

   print("Creating table 'users'")
   	query = [[
CREATE  TABLE `users` (
  `iduser` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
  `username` VARCHAR(45) NOT NULL ,
  `password` VARCHAR(45) NOT NULL ,
  `created` DATETIME NULL ,
  PRIMARY KEY (`iduser`) )
ENGINE = ]] .. mysql_table_engine

   db_query(query)

   print("Inserting " .. users_table_size .. " records into 'users'")
   
   db_bulk_insert_init("INSERT INTO users (username, password, created) VALUES")

   local c_val
   local pad_val


   for j = 1, users_table_size do

   c_val = sb_rand_str([[
###########-###########]])
   pad_val = sb_rand_str([[
###########-###########]])

    db_bulk_insert_next("('".. c_val .."', '" .. pad_val .. "', DATE_SUB(NOW(), INTERVAL "..sb_rand(1,max_history_min) .. " SECOND) )")
   end

   db_bulk_insert_done()

---
--  WALL TABLE
--

   print("Creating table 'wall'")
   	query = [[
CREATE  TABLE `wall` (
  `idwall` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `iduser` BIGINT UNSIGNED NOT NULL ,
  `title` VARCHAR(255) NOT NULL ,
  `message` TEXT NOT NULL ,
  `posted` DATETIME NOT NULL ,
  `viewed_count` BIGINT NOT NULL ,
  `liked_count` BIGINT NOT NULL ,
  `comments_count` INT NOT NULL DEFAULT 0 ,
  `visible` TINYINT UNSIGNED NOT NULL DEFAULT 0 COMMENT 'visibility range 0 - for all 1 - only for approved followers' ,
  PRIMARY KEY (`idwall`) ,
  INDEX `idx_wall_users` (`iduser` ASC) ) 
ENGINE = ]] .. mysql_table_engine

   db_query(query)

   if dbweb_use_fk then
	query = [[  ALTER TABLE wall ADD  CONSTRAINT `fk_wall_users`      FOREIGN KEY (`iduser` )      REFERENCES `users` (`iduser` ) ]]

    db_query(query)

   end


   print("Inserting " .. users_table_size * wall_scale .. " records into 'wall'")
   
   db_bulk_insert_init("INSERT INTO wall (iduser, title, message, posted, viewed_count, liked_count, visible) VALUES")

   local c_val
   local pad_val


   for j = 1, users_table_size * wall_scale do

   c_val = sb_rand_str([[
@@@@@@@@@@@@@@@@@@@@@@-@ @@@@@@@@@@@@@@]])
   pad_val = sb_rand_str([[
@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@ @@@@@@ @@@@@@@@@@@@@ ########]])

    db_bulk_insert_next(string.format("(%u,'%s','%s',DATE_SUB(NOW(), INTERVAL %u SECOND), %u, %u, %u)", 
	sb_rand(1, users_table_size), c_val, pad_val, sb_rand(1, max_history_min), sb_rand(1, users_table_size / wall_view_factor), sb_rand(1, users_table_size / wall_like_factor), (sb_rand_uniform(1,100) < 80) and 0 or 1  ))
     -- visible for all is 80% TODO make it configuring variable 
   end

   db_bulk_insert_done()

--
-- ILIKE table
-- 


   print("Creating table 'ilike'")
   query = [[
CREATE  TABLE `ilike` (
  `idilike` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `iduser` BIGINT UNSIGNED NOT NULL ,
  `idwall` BIGINT UNSIGNED NOT NULL ,
  `liked_date` DATETIME NOT NULL ,
  PRIMARY KEY (`idilike`) ,
  UNIQUE INDEX `unq_user_wall` (`iduser` ASC, `idwall` ASC) )
ENGINE = ]] .. mysql_table_engine

   db_query(query)

   if dbweb_use_fk then
	query = [[  alter table ilike add CONSTRAINT `fk_ilike_users1`      FOREIGN KEY (`iduser` )  REFERENCES `users` (`iduser` )  ]]

    db_query(query)

	query = [[  alter table ilike add CONSTRAINT `fk_ilike_wall1`      FOREIGN KEY (`idwall` )      REFERENCES `wall` (`idwall` )   ]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * ilike_scale .. " records into 'ilike'")
   
   db_bulk_insert_init("INSERT IGNORE INTO ilike (iduser, idwall, liked_date) VALUES")


   for j = 1, users_table_size * ilike_scale do

    db_bulk_insert_next(string.format("(%u, %u, DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), sb_rand(1, users_table_size * wall_scale), sb_rand(1, max_history_min) ))
   end

   db_bulk_insert_done()

--
-- Follow table
-- 


   print("Creating table 'follow'")
   	query = [[
  CREATE TABLE `follow` (
  `idfollow` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `iduser` BIGINT UNSIGNED NOT NULL ,
  `follow_iduser` BIGINT UNSIGNED NOT NULL ,
  `approved` TINYINT UNSIGNED NOT NULL DEFAULT 0 COMMENT '0 - not approved 1 - approved' ,
  `created` DATETIME NOT NULL ,
  PRIMARY KEY (`idfollow`),
  INDEX `idx_follow` (`iduser` ASC, `follow_iduser` ASC, `approved` ASC) ,
  UNIQUE INDEX `unq_follow` (`iduser` ASC, `follow_iduser` ASC) 
 )
ENGINE = ]] .. mysql_table_engine

   db_query(query)

   if dbweb_use_fk then
	query = [[
alter table follow add CONSTRAINT `fk_follow_user1`      FOREIGN KEY (`iduser` )      REFERENCES `users` (`iduser` )
]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * follow_scale .. " records into 'follow'")
   
   db_bulk_insert_init("INSERT IGNORE INTO follow (iduser, follow_iduser, approved, created) VALUES")


   for j = 1, users_table_size * follow_scale do

    db_bulk_insert_next(string.format("(%u, %u, %u, DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), sb_rand(1, users_table_size), (sb_rand_uniform(1,100) < 80) and 1 or 0 ,
        sb_rand(1, max_history_min)))
   end

   db_bulk_insert_done()

--
-- Comments table
-- 


   print("Creating table 'comments'")
   	query = [[
  CREATE TABLE `comments` (
  `idcomment` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `iduser` BIGINT UNSIGNED NOT NULL ,
  `idwall` BIGINT UNSIGNED NOT NULL ,
  `message` TEXT NOT NULL ,
  `posted` DATETIME NOT NULL ,
  PRIMARY KEY (`idcomment`),
  INDEX `idx_idwall` (`idwall` ASC) 
 )
ENGINE = ]] .. mysql_table_engine

   db_query(query)

   if dbweb_use_fk then
	query = [[  alter table comments add CONSTRAINT `fk_comments_users1`      FOREIGN KEY (`iduser` )  REFERENCES `users` (`iduser` )  ]]

    db_query(query)

	query = [[  alter table comments add CONSTRAINT `fk_comments_wall1`      FOREIGN KEY (`idwall` )      REFERENCES `wall` (`idwall` )   ]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * comments_scale .. " records into 'comments'")
   
   db_bulk_insert_init("INSERT IGNORE INTO comments (iduser, idwall, message, posted) VALUES")


   for j = 1, users_table_size * comments_scale do

    db_bulk_insert_next(string.format("(%u, %u,'%s', DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), sb_rand(1, users_table_size*wall_scale), 
        sb_rand_str("@@@@@@@ @@@ @@@@@@@@@@@"),
        sb_rand(1, max_history_min) ) )
   end

   db_bulk_insert_done()

end


function prepare()
   local query
   local i
   local j

   set_vars()

   db_connect()


   for i = 1,dbweb_databases_count do
     create_insert(i)
   end

   return 0
end

function cleanup()
   local i

   set_vars()

   for i = 1,dbweb_databases_count do
   print("Dropping database " .. i .. "'...")
   db_query("DROP DATABASE IF EXISTS sbtest".. i )
   end
end

function set_vars()
   dbweb_databases_count = dbweb_databases_count or 1
   users_table_size = users_table_size or 10000
   wall_scale = wall_scale or 10
   comments_scale = comments_scale or 15
   ilike_scale = ilike_scale or 10
   follow_scale = follow_scale or 10
   wall_view_factor = wall_view_factor or 100 -- how many times wall viewed = users_table_size / wall_view_factor
   wall_like_factor = wall_like_factor or 100 -- how many times wall liked = users_table_size / wall_like_factor
   max_history_min = max_history_min or 1000000 -- how many max minutes from now date walls or comments
   
   if (dbweb_use_fk == 'on') then
      dbweb_use_fk = true
   else
      dbweb_use_fk = false
   end

   if (dbweb_read_only == 'on') then
      dbweb_read_only = true
   else
      dbweb_read_only = false
   end

end
